﻿using AirplaneWithRadar.PaintObjects;
using AirplaneWithRadar.Entities;

namespace AirplaneWithRadar
{
    internal class AirplaneCompareByColor : IComparer<PaintAirplane?>
    {
        public int Compare(PaintAirplane? x, PaintAirplane? y)
        {
            if (x == null || x.AirplaneEntity == null)
            {
                throw new ArgumentNullException(nameof(x));
            }
            if (y == null || y.AirplaneEntity == null)
            {
                throw new ArgumentNullException(nameof(y));
            }
            if (x.GetType().Name != y.GetType().Name)
            {
                return x.GetType().Name.CompareTo(y.GetType().Name);
            }
            var colorCompare = x.AirplaneEntity.BodyColor.Name.CompareTo(y.AirplaneEntity.BodyColor.Name);
            if (!(x is PaintAirplaneWithRadar && y is PaintAirplaneWithRadar))
            {
                return colorCompare;
            }
            return ((AirplaneWithRadarEntity)x.AirplaneEntity).AdditColor.Name.CompareTo(((AirplaneWithRadarEntity)y.AirplaneEntity).AdditColor.Name);
        }
    }
}
