﻿using AirplaneWithRadar.PaintObjects;

namespace AirplaneWithRadar.Generics
{
    internal class AirplaneCompareByType : IComparer<PaintAirplane?>
    {
        public int Compare(PaintAirplane? x, PaintAirplane? y)
        {
            if (x == null || x.AirplaneEntity == null)
            {
                throw new ArgumentNullException(nameof(x));
            }
            if (y == null || y.AirplaneEntity == null)
            {
                throw new ArgumentNullException(nameof(y));
            }
            if (x.GetType().Name != y.GetType().Name)
            {
                return x.GetType().Name.CompareTo(y.GetType().Name);
            }
            var speedCompare = x.AirplaneEntity.Speed.CompareTo(y.AirplaneEntity.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            return x.AirplaneEntity.Weight.CompareTo(y.AirplaneEntity.Weight);
        }

    }
}
