﻿using AirplaneWithRadar.Entities;

namespace AirplaneWithRadar.PaintObjects
{
    public static class ExtentionPaintAirplane
    {
        public static PaintAirplane? CreatePaintAirplane(this string info, char separatorForObject, int width, int height)
        {
            string[] strs = info.Split(separatorForObject);
            if (strs.Length == 3)
            {
                return new PaintAirplane(Convert.ToInt32(strs[0]),
                Convert.ToInt32(strs[1]), Color.FromName(strs[2]), width, height);
            }
            if (strs.Length == 6)
            {
                return new PaintAirplaneWithRadar(Convert.ToInt32(strs[0]),
                Convert.ToInt32(strs[1]),
                Color.FromName(strs[2]),
                Color.FromName(strs[3]),
                Convert.ToBoolean(strs[4]),
                Convert.ToBoolean(strs[5]), width, height);
            }
            return null;
        }
        public static string GetDataForSave(this PaintAirplane paintAirplane, char separatorForObject)
        {
            var airplane = paintAirplane.AirplaneEntity;
            if (airplane == null)
            {
                return string.Empty;
            }
            var str = $"{airplane.Speed}{separatorForObject}{airplane.Weight}{separatorForObject}{airplane.BodyColor.Name}";
            if (airplane is not AirplaneWithRadarEntity airplaneWithRadar)
            {
                return str;
            }
            return $"{str}{separatorForObject}{airplaneWithRadar.AdditColor.Name}{separatorForObject}{airplaneWithRadar.RadarOnBoard}" +
            $"{separatorForObject}{airplaneWithRadar.AdditFuelPod}";
        }
    }

}


