﻿using AirplaneWithRadar.PaintObjects;
using AirplaneWithRadar.Entities;
using System.Diagnostics.CodeAnalysis;

namespace AirplaneWithRadar.Generics;

internal class PaintAirplaneEqutables : IEqualityComparer<PaintAirplane>
{
    public bool Equals(PaintAirplane? x, PaintAirplane? y)
    {
        if (x == null || x.AirplaneEntity == null)
        {
            throw new ArgumentNullException(nameof(x));
        }
        if (y == null || y.AirplaneEntity == null)
        {
            throw new ArgumentNullException(nameof(y));
        }
        if (x.GetType().Name != y.GetType().Name)
        {
            return false;
        }
        if (x.AirplaneEntity.Speed != y.AirplaneEntity.Speed)
        {
            return false;
        }
        if (x.AirplaneEntity.Weight != y.AirplaneEntity.Weight)
        {
            return false;
        }
        if (x.AirplaneEntity.BodyColor != y.AirplaneEntity.BodyColor)
        {
            return false;
        }
        if (x is PaintAirplaneWithRadar && y is PaintAirplaneWithRadar)
        {
            AirplaneWithRadarEntity xEntity = (AirplaneWithRadarEntity)x.AirplaneEntity;
            AirplaneWithRadarEntity yEntity = (AirplaneWithRadarEntity)x.AirplaneEntity;
            if (xEntity.AdditColor != yEntity.AdditColor)
            {
                return false;
            }
            if (xEntity.AdditFuelPod != yEntity.AdditFuelPod)
            {
                return false;
            }
            if (xEntity.RadarOnBoard != yEntity.AdditFuelPod)
            {
                return false;
            }
        }
        return true;
    }
    public int GetHashCode([DisallowNull] PaintAirplane obj)
    {
        return obj.GetHashCode();
    }
}
