﻿using AirplaneWithRadar.PaintObjects;


namespace AirplaneWithRadar.MovementStrategy
{
    public class PaintObjectAirplane : IMoveableObject
    {
        private readonly PaintAirplane? paintAirplane = null;

        public PaintObjectAirplane(PaintAirplane paintAirplane)
        {
            this.paintAirplane = paintAirplane;
        }

        public ObjectParameters? GetObjectPosition
        {
            get
            {
                if (paintAirplane == null || paintAirplane.AirplaneEntity == null) { return null; }
                return new ObjectParameters(paintAirplane.GetPosX, paintAirplane.GetPosY, paintAirplane.GetWidth, paintAirplane.GetHeight);
            }
        }

        public int GetStep => (int)(paintAirplane?.AirplaneEntity?.Step ?? 0);
        public bool CheckCanMove(Movement dir) =>
        paintAirplane?.CanMove(dir) ?? false;
        public void MoveObject(Movement dir) =>
        paintAirplane?.Move(dir);
            
    }
}
